'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.remove = exports.list = exports.add = exports.getConfig = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var setConfig = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(conf) {
    var spinner;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            spinner = (0, _ora2.default)({ text: '操作成功, 已写入配置文件' });
            _context.next = 3;
            return (0, _es6Promisify2.default)(_fs2.default.writeFile)(configFile, JSON.stringify(conf));

          case 3:
            spinner.succeed();
            return _context.abrupt('return', conf);

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function setConfig(_x) {
    return _ref.apply(this, arguments);
  };
}();

var add = exports.add = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(name) {
    var config, conf;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            config = getConfig();
            conf = void 0;

            if (!/^@/.test(name)) {
              _context2.next = 9;
              break;
            }

            _context2.next = 5;
            return _inquirer2.default.prompt(addPrompts(config).slice(1));

          case 5:
            conf = _context2.sent;

            conf.namespace = name;
            _context2.next = 12;
            break;

          case 9:
            _context2.next = 11;
            return _inquirer2.default.prompt(addPrompts(config));

          case 11:
            conf = _context2.sent;

          case 12:
            _context2.next = 14;
            return setConfig(config.concat(conf));

          case 14:
            return _context2.abrupt('return', conf);

          case 15:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function add(_x2) {
    return _ref2.apply(this, arguments);
  };
}();

var list = exports.list = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
    var config, _ref4, choice;

    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            config = getConfig();
            _context3.next = 3;
            return _inquirer2.default.prompt(listPrompts(config));

          case 3:
            _ref4 = _context3.sent;
            choice = _ref4.choice;

            console.log(config.filter(function (v) {
              return v.namespace === choice;
            })[0]);

          case 6:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function list() {
    return _ref3.apply(this, arguments);
  };
}();

var remove = exports.remove = function () {
  var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
    var config, _ref6, choice, confirm;

    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            config = getConfig();
            _context4.next = 3;
            return _inquirer2.default.prompt(removePrompts(config));

          case 3:
            _ref6 = _context4.sent;
            choice = _ref6.choice;
            confirm = _ref6.confirm;

            if (!confirm) {
              _context4.next = 9;
              break;
            }

            _context4.next = 9;
            return setConfig(config.filter(function (v) {
              return v.namespace !== choice;
            }));

          case 9:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function remove() {
    return _ref5.apply(this, arguments);
  };
}();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _es6Promisify = require('es6-promisify');

var _es6Promisify2 = _interopRequireDefault(_es6Promisify);

var _ora = require('ora');

var _ora2 = _interopRequireDefault(_ora);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var home = process.env[process.platform === 'win32' ? 'USERPROFILE' : 'HOME'];
var configFile = _path2.default.join(home, '.release-man-config');

var DEFAULT_CONFIG = [{
  namespace: 'npm(official)',
  official: true,
  registry: 'https://registry.npmjs.org',
  website: 'https://npmjs.org'
}, {
  namespace: '@cnpm',
  registry: 'https://registry.npm.taobao.org',
  website: 'https://npm.taobao.org'
}];

var getConfig = exports.getConfig = function getConfig() {
  var config = DEFAULT_CONFIG;

  try {
    config = JSON.parse(_fs2.default.readFileSync(configFile, 'utf8'));
  } catch (e) {}

  return config;
};

var reURL = /^https?:\/\/[\w.:]+\/?$/;

/**
 * 配置文件
 * namespace: 内网源的命名空间
 * registry: 内部源，如 https://registry.npm.taobao.org
 * website: 内部源网页，如 https://npm.taobao.org/
 */

var addPrompts = function addPrompts(config) {
  return [{
    type: 'input',
    name: 'namespace',
    message: '请输入内部源命名空间(如 @cnpm):',
    validate: function validate(v) {
      var ns = config.map(function (v) {
        return v.namespace;
      });

      if (!/^@/.test(v)) {
        return '\u547D\u540D\u7A7A\u95F4 ' + v + ' \u4E0D\u5408\u6CD5\uFF0C\u5E94\u4EE5 @ \u5F00\u5934';
      }

      if (ns.indexOf(v) > -1) {
        return '\u547D\u540D\u7A7A\u95F4 ' + v + ' \u5DF2\u5B58\u5728\uFF0C\u8BF7\u8FD0\u884C release list \u67E5\u770B';
      }

      return true;
    }
  }, {
    type: 'input',
    name: 'registry',
    message: '请输入内部源(如 https://registry.npm.taobao.org)\n:',
    validate: function validate(v) {
      if (!reURL.test(v)) {
        return '\u5185\u90E8\u6E90 ' + v + ' \u4E0D\u662F\u5408\u6CD5\u7684\u7F51\u5740';
      }

      return true;
    }
  }, {
    type: 'input',
    name: 'website',
    message: '请输入内部源页面地址(便于发外网时同步 如 https://npm.taobao.org)\n:',
    validate: function validate(v) {
      if (v && !reURL.test(v)) {
        return '\u5185\u90E8\u6E90\u9875\u9762\u5730\u5740 ' + v + ' \u4E0D\u662F\u5408\u6CD5\u7684\u7F51\u5740';
      }

      return true;
    }
  }];
};

var listPrompts = function listPrompts(config) {
  return [{
    type: 'list',
    name: 'choice',
    message: '请选择要查看的命名空间',
    choices: config.map(function (v) {
      return v.namespace;
    })
  }];
};

var removePrompts = function removePrompts(config) {
  return [{
    type: 'list',
    name: 'choice',
    message: '请选择要删除的命名空间',
    choices: config.filter(function (v) {
      return !v.official;
    }).map(function (v) {
      return v.namespace;
    })
  }, {
    type: 'confirm',
    name: 'confirm',
    message: '确认要删除该命名空间的配置吗?',
    when: function when(answers) {
      return answers.choice;
    }
  }];
};

;