'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var syncTags = function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(options) {
        var cVersion, questions, forceQ, tagList, tags, remote, _ref2, version, github, tagName, _ref3, _github;

        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        cVersion = content.version;
                        questions = [{
                            type: 'input',
                            name: 'version',
                            message: '请输入要发布的版本号:',
                            default: cVersion,
                            validate: function validate(content) {
                                if (rVersion.test(content) || !content) {
                                    return true;
                                }
                                return '\u7248\u672C\u53F7 ' + content + ' \u4E0D\u5408\u6CD5\uFF0C\u6B63\u786E\u7684\u683C\u5F0F\u5E94\u4E3A: 1.0.2 \u6216 2.3.0-beta.1';
                            }
                        }];
                        forceQ = [questions[1]];
                        _context.prev = 3;

                        spinner.start();

                        _context.next = 7;
                        return ep(exec)('git tag');

                    case 7:
                        tagList = _context.sent;
                        tags = tagList.split(/[\r\n]/).filter(function (v) {
                            return v;
                        });
                        _context.next = 11;
                        return parseRemote();

                    case 11:
                        remote = _context.sent;


                        spinner.text = '检测 git tags 成功';
                        spinner.succeed();

                        if (options.all) {
                            _context.next = 23;
                            break;
                        }

                        _context.next = 17;
                        return inquirer.prompt(questions);

                    case 17:
                        _ref2 = _context.sent;
                        version = _ref2.version;
                        github = _ref2.github;
                        tagName = 'v' + version;
                        _context.next = 27;
                        break;

                    case 23:
                        _context.next = 25;
                        return inquirer.prompt(forceQ);

                    case 25:
                        _ref3 = _context.sent;
                        _github = _ref3.github;

                    case 27:
                        _context.next = 33;
                        break;

                    case 29:
                        _context.prev = 29;
                        _context.t0 = _context['catch'](3);

                        spinner.text = _context.t0.message;
                        spinner.fail();

                    case 33:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this, [[3, 29]]);
    }));

    return function syncTags(_x) {
        return _ref.apply(this, arguments);
    };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fs = require('fs');
var path = require('path');
var inquirer = require('inquirer');
var ep = require('es6-promisify');

var _require = require('child_process'),
    exec = _require.exec;

var ora = require('ora');

var spinner = ora({ text: '检查中' });

var cwd = process.cwd();
var pkgPath = path.join(cwd, 'package.json');
var pkg = fs.readFileSync(pkgPath, 'utf8');
var content = JSON.parse(pkg);
var rVersion = /^\d+\.\d+\.\d+(?:-(.+))?$/;

;

exports.default = syncTags;