'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.spinning = exports.getCurrentBranch = exports.parseRemote = exports.updateVersion = exports.log = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var updateVersion = exports.updateVersion = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(version) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            content.version = version;
            _context.next = 3;
            return (0, _es6Promisify2.default)(_fs2.default.writeFile)(pkgPath, JSON.stringify(content, null, 2), 'utf8');

          case 3:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function updateVersion(_x) {
    return _ref.apply(this, arguments);
  };
}();

var parseRemote = exports.parseRemote = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    var remotes, rGithub, githubMatched, remote;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _es6Promisify2.default)(_child_process.exec)('git remote -v');

          case 2:
            remotes = _context2.sent;
            rGithub = /(\w+)\s+.+github.+/;
            githubMatched = remotes.match(rGithub);
            remote = {};


            if (githubMatched && githubMatched[1]) remote.github = githubMatched[1];

            return _context2.abrupt('return', remote);

          case 8:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function parseRemote() {
    return _ref2.apply(this, arguments);
  };
}();

var getCurrentBranch = exports.getCurrentBranch = function () {
  var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return (0, _es6Promisify2.default)(_child_process.exec)('git describe --contains --all HEAD');

          case 2:
            return _context3.abrupt('return', _context3.sent);

          case 3:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function getCurrentBranch() {
    return _ref3.apply(this, arguments);
  };
}();

var spinning = exports.spinning = function () {
  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(msg, cb) {
    var spinner, result;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            spinner = (0, _ora2.default)(msg);

            spinner.start();
            _context4.next = 4;
            return cb(spinner);

          case 4:
            result = _context4.sent;

            result ? spinner.succeed() : spinner.stopAndPersist('◎');

          case 6:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function spinning(_x2, _x3) {
    return _ref4.apply(this, arguments);
  };
}();

exports.sync = sync;
exports.goodbye = goodbye;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _es6Promisify = require('es6-promisify');

var _es6Promisify2 = _interopRequireDefault(_es6Promisify);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _ora = require('ora');

var _ora2 = _interopRequireDefault(_ora);

var _child_process = require('child_process');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var cwd = process.cwd();
var pkgPath = _path2.default.join(cwd, 'package.json');
var pkg = _fs2.default.readFileSync(pkgPath, 'utf8');
var content = JSON.parse(pkg);

var log = exports.log = {
  done: function done(msg) {
    return console.log(_chalk2.default.green('\u2714 ' + msg));
  },
  error: function error(err) {
    return console.log(_chalk2.default.red('\xD7 ' + err));
  },
  info: function info(msg) {
    return console.log(_chalk2.default.blue('\u25B3 ' + msg));
  },
  dim: function dim(msg) {
    return console.log(_chalk2.default.dim('\u25CE ' + msg));
  }
};

function sync(name, urlList) {
  return Promise.all(urlList.map(function (url) {
    var u = /\/$/.test(url) ? url : url + '/';
    return (0, _nodeFetch2.default)(u + 'sync/' + name, {
      method: 'PUT',
      // 10秒超时
      timeout: 10000
    }).then(function (response) {
      if (!response.ok) {
        throw new Error(response.statusText);
      }
    });
  }));
}

function goodbye() {
  var list = ['提乾涉经', '人群当中看见了一个光头', '不要打架', '身体健康', '带着小姨子跑了', '也是一个广♂东人', '乖♂乖站好', '吔屎啦', '一百块都不给我', '什么仇什么怨', '大力出奇迹', '倒戈卸甲, 以礼来降', '啊♂快哉', '瞬间爆炸', 'Are you OK', '八百标兵奔北坡\n北坡炮兵并排跑\n炮兵怕把标兵碰\n标兵怕碰炮兵炮\n'];

  var i = Math.floor(Math.random() * list.length);
  return '\u6700\u540E\u795D\u4F60, ' + list[i] + ', \u518D\u89C1!';
}